using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Specialized;
using System.Diagnostics;

namespace runlater
{
	/// <summary>
	/// Zusammenfassung fr Form.
	/// </summary>
	public class Form : System.Windows.Forms.Form
	{

		static StringDictionary argList = new StringDictionary();
		public System.Windows.Forms.Label prog;
		public System.Windows.Forms.Label sec;
		private System.Windows.Forms.Timer timer;
		private System.Windows.Forms.Button cancel;
		private System.Windows.Forms.Panel panel;
		private System.Windows.Forms.ToolTip toolTip;
		private System.ComponentModel.IContainer components;
		static private int delta = 1;

		public Form()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form));
			this.prog = new System.Windows.Forms.Label();
			this.sec = new System.Windows.Forms.Label();
			this.timer = new System.Windows.Forms.Timer(this.components);
			this.cancel = new System.Windows.Forms.Button();
			this.panel = new System.Windows.Forms.Panel();
			this.toolTip = new System.Windows.Forms.ToolTip(this.components);
			this.panel.SuspendLayout();
			this.SuspendLayout();
			// 
			// prog
			// 
			this.prog.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.prog.Location = new System.Drawing.Point(80, 8);
			this.prog.Name = "prog";
			this.prog.Size = new System.Drawing.Size(642, 24);
			this.prog.TabIndex = 0;
			this.prog.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.toolTip.SetToolTip(this.prog, "Klick auf das Fenster minimiert das Programm in die Taskleiste.");
			this.prog.Click += new System.EventHandler(this.minimize_Click);
			// 
			// sec
			// 
			this.sec.Location = new System.Drawing.Point(8, 8);
			this.sec.Name = "sec";
			this.sec.Size = new System.Drawing.Size(56, 24);
			this.sec.TabIndex = 1;
			this.sec.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.toolTip.SetToolTip(this.sec, "Klick auf das Fenster minimiert das Programm in die Taskleiste.");
			this.sec.Click += new System.EventHandler(this.minimize_Click);
			// 
			// timer
			// 
			this.timer.Interval = 1000;
			this.timer.Tick += new System.EventHandler(this.timer_Tick);
			// 
			// cancel
			// 
			this.cancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cancel.BackColor = System.Drawing.SystemColors.Control;
			this.cancel.Font = new System.Drawing.Font("Arial Narrow", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cancel.Location = new System.Drawing.Point(730, 8);
			this.cancel.Name = "cancel";
			this.cancel.Size = new System.Drawing.Size(48, 24);
			this.cancel.TabIndex = 2;
			this.cancel.Text = "Cancel";
			this.toolTip.SetToolTip(this.cancel, "Der Start wird abgebrochen.");
			this.cancel.Click += new System.EventHandler(this.cancel_Click);
			// 
			// panel
			// 
			this.panel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel.Controls.Add(this.cancel);
			this.panel.Controls.Add(this.prog);
			this.panel.Controls.Add(this.sec);
			this.panel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel.Location = new System.Drawing.Point(0, 0);
			this.panel.Name = "panel";
			this.panel.Size = new System.Drawing.Size(784, 40);
			this.panel.TabIndex = 3;
			this.toolTip.SetToolTip(this.panel, "Klick auf das Fenster minimiert das Programm in die Taskleiste.");
			// 
			// Form
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.ClientSize = new System.Drawing.Size(784, 40);
			this.Controls.Add(this.panel);
			this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form";
			this.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.WindowState = System.Windows.Forms.FormWindowState.Minimized;
			this.panel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>

		static Form form = new Form();

		[STAThread]
		static void Main(string[] args) 
		{
			for (int i = 0; i < args.Length; i++) {
				string [] pair = (args[i] + "=").Split(new char[] {'='});
				argList.Add(pair[0],pair[1]);
			}
			if (argList["sec"] == null || argList["run"] == null) {
				Help help = new Help();
				Application.Run(help);
			} else {
				if (argList["delta"] != null) {
					delta = Convert.ToInt32(argList["delta"]);
					if (delta <= 0) delta = 1;
				}
				form.prog.Text = argList["run"] + " " + argList["arg"];
				form.sec.Text = argList["sec"] + " sec";
				Bitmap bmp = new Bitmap(1, 1);
				Graphics graphics = Graphics.FromImage(bmp);  
				SizeF stringSize = graphics.MeasureString(form.prog.Text,form.prog.Font);
				form.Width = Convert.ToInt32(stringSize.Width) + 150;
				form.timer.Start();
				Application.Run(form);
			}
		}

		private void timer_Tick(object sender, System.EventArgs e) {
			int sec = Convert.ToInt32(argList["sec"]);
			if (sec <= 0) {
				form.timer.Stop();
				Process.Start(argList["run"],argList["arg"]);
				form.Close();
			} else {
				sec -= delta;
				if (sec < 0) sec = 0;
				argList["sec"] = sec.ToString();
				form.sec.Text = argList["sec"] + " sec";
				int idx = argList["run"].LastIndexOf('\\') + 1;
				form.Text = argList["run"].Substring(idx) + " " + form.sec.Text;
			}
		}

		private void cancel_Click(object sender, System.EventArgs e) {
			form.timer.Stop();
			form.Close();		
		}

		private void minimize_Click(object sender, System.EventArgs e) {
			form.WindowState = FormWindowState.Minimized;
		}
	}
}
